<template>
  <div>
    <div class="uk-card uk-card-small uk-card-default uk-card-body rounded my-2">
      <label for="search">
        {{ $t("Search") }}
        <input class="form-input !w-1/6" id="search" type="text" @input="searchData" v-model="search">
      </label>
    </div>

    <div class="flex items-center mb-2 ">
      <button class="btn-success w-1/12 ml-auto" uk-toggle="target: #listing-types" @click="typeData = {}">{{
        $t("Add") }}</button>
    </div>


    <!-- table -->
    <!-- {{ listingTypesStorage.listingRealEstateTypesSubeType }} -->
    <EasyDataTable rows-per-page-text="rowsPerPageText" @click-row="showRow"
      :header-item-class-name="headerItemClassNameFunction" theme-color="#7367f0" buttons-pagination :headers="headers"
      :items="listingTypesStorage.listingRealEstateTypesSubeType.data" id="user-table">

      <template #empty-message>
        <span>{{ t('empty_text') }}</span>
      </template>

      <template #header="data">
        {{ t(data.text) }}
      </template>

      <template #item-type_name="item">
        {{ item.type_name[$i18n.locale] }}
      </template>

      <template #item-description="item">
        <span v-if="item.description">
          {{ item.description[$i18n.locale] }}
        </span>
      </template>

      <template #item-actions="item">
        <div class="float-right">
          <button uk-toggle="target: #listing-types" @click.stop="typeData = item"
            class="rounded-md bg-warning px-3 py-1.5 text-white duration-100 hover:opacity-90">
            <span uk-icon="icon: pencil" class="uk-icon"></span>
          </button>
          <button class="rounded-md bg-danger ml-3 px-3 py-1.5 text-white duration-100 hover:opacity-90"
            @click.stop="deleteSubMenu(item.id)">
            <span uk-icon="icon: trash" class="uk-icon"></span>
          </button>
        </div>
      </template>
    </EasyDataTable>
    <!-- {{ typeData }}
    {{ typeDataEdit }} -->

    <!-- Add Modal -->
    <div id="listing-types" class="uk-flex-top" uk-modal @shown="showModal">
      <div class="uk-modal-dialog uk-margin-auto-vertical rounded-md overflow-hidden">
        <button class="uk-modal-close-default" type="button" uk-close @click="clearData"></button>
        <div class="uk-modal-header">
          <h2 class="uk-modal-title text-xl text-[#4b4b4b] font-normal">
            {{ typeData.id ? $t('Edit') : $t('Add') }}
          </h2>
        </div>
        <div class="uk-modal-body">
          <!-- {{ typeDataEdit }} -->
          <Tabs>
            <Tab title="RU">
              <div class="uk-margin">
                <label for="default" class="text-gray-700 select-none font-medium w-1/4">
                  {{ $t("title") + '_RU' }}
                  <input v-model="typeDataEdit.type_name.ru" id="default" type="text" name="default"
                    :placeholder="$t('title')"
                    class="block px-4 py-2 rounded-lg border border-gray-300 focus:outline-none focus:ring-2 focus:ring-gray-200 w-full" />
                </label>
              </div>

              <div class="uk-margin">
                <label for="default" class="text-gray-700 select-none font-medium w-1/4">
                  {{ $t("description") + '_RU' }}
                  <textarea v-model="typeDataEdit.description.ru"
                    class="block px-4 py-2 rounded-lg border border-gray-300 focus:outline-none focus:ring-2 focus:ring-gray-200 w-full"></textarea>
                </label>
              </div>
            </Tab>

            <Tab title="UZ" active>
              <div class="uk-margin">
                <label for="default" class="text-gray-700 select-none font-medium w-1/4">
                  {{ $t("title") + '_UZ' }}
                  <input v-model="typeDataEdit.type_name.uz" id="default" type="text" name="default"
                    :placeholder="$t('title')"
                    class="block px-4 py-2 rounded-lg border border-gray-300 focus:outline-none focus:ring-2 focus:ring-gray-200 w-full" />
                </label>
              </div>

              <div class="uk-margin">
                <label for="default" class="text-gray-700 select-none font-medium w-1/4">
                  {{ $t("description") + '_UZ' }}
                  <textarea v-model="typeDataEdit.description.uz"
                    class="block px-4 py-2 rounded-lg border border-gray-300 focus:outline-none focus:ring-2 focus:ring-gray-200 w-full"></textarea>
                </label>
              </div>
            </Tab>

            <Tab title="CYR">
              <div class="uk-margin">
                <label for="default" class="text-gray-700 select-none font-medium w-1/4">
                  {{ $t("title") + '_CYR' }}
                  <input v-model="typeDataEdit.type_name.cryl" id="default" type="text" name="default"
                    :placeholder="$t('title')"
                    class="block px-4 py-2 rounded-lg border border-gray-300 focus:outline-none focus:ring-2 focus:ring-gray-200 w-full" />
                </label>
              </div>

              <div class="uk-margin">
                <label for="default" class="text-gray-700 select-none font-medium w-1/4">
                  {{ $t("description") + '_CYR' }}
                  <textarea v-model="typeDataEdit.description.cryl"
                    class="block px-4 py-2 rounded-lg border border-gray-300 focus:outline-none focus:ring-2 focus:ring-gray-200 w-full"></textarea>
                </label>
              </div>
            </Tab>



          </Tabs>

          <div class="uk-margin">
            <label for="default" class="text-gray-700 select-none font-medium w-1/4">
              {{ $t("main_type") }}
              <v-select id="state" multiple="true" v-model="typeDataEdit.main_types" :options="mainTypeList"
                :reduce="(el => el.id)" label="title" class="!rounded-md" :placeholder='t("main_type")' />
            </label>
          </div>

        </div>

        <div class="uk-modal-footer px-5 py-3 uk-text-right bg-white flex justify-end">
          <button uk-toggle="target: #listing-types" class="btn-small btn-danger mr-2">
            {{ t('Close') }}
          </button>
          <button @click="postData" uk-toggle="target: #listing-types"
            :class="`rounded-md px-6 py-2 text-white duration-100 hover:opacity-90 ${typeData.id ? 'bg-warning' : 'bg-success'}`">
            {{ typeData.id ? $t('Edit') : $t('Save') }}
          </button>
        </div>
      </div>
    </div>

  </div>
</template>


<script lang="ts" setup>
import { onMounted } from "vue";
import { listingTypes } from "@/stores/listingTypes";
import { toast } from "vue3-toastify";
import { ref } from "vue";

import Tabs from "@/components/Tab/Tabs.vue";
import Tab from "@/components/Tab/Tab.vue";
import Swal from 'sweetalert2'
import { useRouter } from "vue-router"
import { useI18n } from 'vue-i18n'
const { t, locale } = useI18n()

const router = useRouter()

let search = ref("")
let mainTypeList = ref([
  {
    id: 5,
    title: "Жилье"
  },
  {
    id: 4,
    title: "Коммерческое"
  }
])

interface TypeDataEdit {
  description: {
    uz: string;
    ru: string;
    cryl: string
  };
  type_name: {
    uz: string;
    ru: string;
    cryl: string
  };
  main_types: number[]
}

interface TypeData {
  id?: string;
  description?: {
    uz: string;
    ru: string;
    cryl: string
  };
  type_name?: {
    uz: string;
    ru: string;
    cryl: string
  };
  main_types: number[]
}

let typeDataEdit = ref<TypeDataEdit>({
  description: {
    ru: "",
    uz: "",
    cryl: ""
  },
  type_name: {
    ru: "",
    uz: "",
    cryl: ""
  },
  main_types: []
});

let typeData = ref<TypeData>({
  id: "",
  description: {
    ru: "",
    uz: "",
    cryl: ""
  },
  type_name: {
    ru: "",
    uz: "",
    cryl: ""
  },
  main_types: []
});

const deleteId = ref({
  id: ""
})

const listingTypesStorage = listingTypes();



function showModal() {
  if (typeData.value.id) {
    if (typeData.value.type_name) {
      typeDataEdit.value.type_name = JSON.parse(JSON.stringify(typeData.value.type_name))
    }
    if (typeData.value.description) {
      typeDataEdit.value.description = JSON.parse(JSON.stringify(typeData.value.description))
    }
  } else {
    typeDataEdit.value = {
      description: {
        ru: "",
        uz: "",
        cryl: ""
      },
      type_name: {
        ru: "",
        uz: "",
        cryl: ""
      },
    }
  }
}

function clearData() {
  typeData.value.type_name = {
    ru: "",
    uz: "",
  };
}


onMounted(() => {
  listingTypesStorage.FETCH_REAL_ESTATE_TYPES_SUBE_TYPE({
    limit: 10, page: 1
  });


});

const headerItemClassNameFunction = (header): string => {
  if (header.value === "actions") return "float-right mr-12";
  return "";
};
function showRow(data) {
  console.log(data);

  router.push({ name: 'listing-detail', params: { id: data.id } })

}

const deleteSubMenu = (id: number) => {

  Swal.fire({
    title: 'Are you sure?',
    text: "You won't be able to revert this!",
    icon: 'warning',
    showCancelButton: true,
    confirmButtonColor: '#3085d6',
    cancelButtonColor: '#d33',
    confirmButtonText: 'Yes, delete it!'
  }).then((result) => {
    if (result.isConfirmed) {
      console.log(result);

      listingTypesStorage.DELETE_SUBE_TYPE(id).then(() => {
        listingTypesStorage.FETCH_REAL_ESTATE_TYPES_SUBE_TYPE(
          {
            limit: 10, page: 1
          }
        );
        toast.success("success");
      });

    }
  })
}

const headers = [
  {
    text: "id",
    value: "id",
  },
  {
    text: "name",
    value: "type_name",
  },
  {
    text: "description",
    value: "description"
  },
  {
    text: "actions",
    value: "actions"
  },
];

function postData() {
  if (typeData.value.id) {
    listingTypesStorage.UPDATE_SUBE_TYPE({ type_id: typeData.value.id, ...typeDataEdit.value }).then(() => {
      listingTypesStorage.FETCH_REAL_ESTATE_TYPES_SUBE_TYPE(
        {
          limit: 10, page: 1
        }
      );
      toast.success("success");
      clearData
    });
  } else {
    listingTypesStorage.CREATE_REAL_ESTATE_TYPES_SUBE_TYPE(typeDataEdit.value).then(() => {
      listingTypesStorage.FETCH_REAL_ESTATE_TYPES_SUBE_TYPE(
        {
          limit: 10, page: 1
        }
      );
      toast.success("success");
      clearData
    });
  }
}

function deleteType() {
  listingTypesStorage.DELETE_SUBE_TYPE(deleteId.value.id).then(() => {
    listingTypesStorage.FETCH_REAL_ESTATE_TYPES_SUBE_TYPE(
      listingTypesStorage.listingRealEstateTypesSubeType.data
    );
    toast.success("success");
  });
}

function searchData() {
  console.log(search.value);

  // listingTypesStorage.FETCH_REAL_ESTATE_TYPES_SUBE_TYPE(
  //   search.value
  //   );
}
</script>

<style lang="scss">
@import url(../../assets/userTable.css);

.dark-layout {
  .input-dark {
    background: #283046;
  }
}
</style>